$PROG &HFF,&HFF,&HDF,&H00' generated. Take care that the chip supports all fuse bytes.'
'Author: Rodman, vitalijrodnov@gmail.com
'
$regfile = "attiny2313.dat"
$crystal = 10000000

Declare Sub Left_blink
Declare Sub Right_blink
Declare Sub Go_forward
Declare Sub Go_back
Declare Sub Go_left
Declare Sub Turn_left
Declare Sub Go_right
Declare Sub Turn_right
Declare Sub Stop_it
Declare Sub Back_left
Declare Sub Back_right
Declare Sub Button
Declare Sub Leds(byval Count As Byte)

Dim Address As Byte , Command As Byte
Dim Led_on As Byte , Led_off As Byte
Dim Object As Byte , I As Byte
Const No_object = 0
Const Right_object = 1
Const Left_object = 4
Const Center_object = 5

Ocr0a = 131 : Ocr0b = 131

Config Portb.3 = Output                                     'Left  SERVO control
Config Portb.4 = Output                                     'Right SERVO control
Config Pind.0 = Input                                       'Left  TSOP out
Config Pinb.0 = Input                                       'Right TSOP out
Config Portd.4 = Output                                     'Left  detect led
Config Portb.1 = Output                                     'Right detect led
Config Portd.5 = Output                                     'Left  LEDS 38kHz
Config Portb.2 = Output                                     'Right LEDS 38kHz
Config Pind.3 = Input                                       'Left  Line OUT
Config Pind.2 = Input                                       'Right Line OUT
Config Rc5 = Pind.0

Config Timer1 = Pwm , Pwm = 8 , Compare A Pwm = Clear Up , Compare B Pwm = Clear Up , Prescale = 256
Enable Interrupts


Main_menu:
Set Portb.1
Do
Button
Select Case Command
   Case 1 : Goto First_test
   Case 2 : Goto Agresyvus
   Case 3 : Goto Bailys
   Case 4 : Goto Smalsus
   Case 5 : Goto Atsargus
   Case 6 : Goto Zombi
End Select
Loop

First_test:
Leds 1
Do
Left_blink : Right_blink
Select Case Object
   Case No_object : Stop_it
   Case Right_object : Turn_right
   Case Left_object : Turn_left
   Case Center_object : Go_forward
End Select
Object = 0
Loop

Agresyvus:
Leds 2
Do
Left_blink : Right_blink
Select Case Object
   Case No_object : Stop_it
   Case Right_object : Go_right
   Case Left_object : Go_left
   Case Center_object : Go_forward
End Select
Object = 0
Loop

Bailys:
Leds 3
Do
Left_blink : Right_blink
Select Case Object
   Case No_object : Stop_it
   Case Right_object : Back_left
   Case Left_object : Back_right
   Case Center_object : Go_back
End Select
Object = 0
Loop

Smalsus:
Leds 4
Do
Left_blink : Right_blink
Select Case Object
   Case No_object : Go_forward
   Case Right_object
      Turn_left : Waitms 200
   Case Left_object
      Turn_right : Waitms 300
   Case Center_object
      Go_back : Waitms 200
      Turn_right : Waitms 200
End Select
Object = 0
Loop

Atsargus:
Leds 5
Do
Left_blink : Right_blink
Select Case Object
   Case No_object
      Go_back : Waitms 300
      Turn_right : Waitms 200
   Case Right_object
      Turn_right : Waitms 300
   Case Left_object
      Turn_left : Waitms 300
   Case Center_object : Go_forward
End Select
Object = 0
Loop

Zombi:
Leds 6
Do
Button
Select Case Command
   Case 2 : Go_forward
   Case 8 : Go_back
   Case 5 : Stop_it
   Case 4 : Turn_left
   Case 6 : Turn_right
   Case 7 : Back_right
   Case 9 : Back_left
   Case 1 : Go_left
   Case 3 : Go_right
End Select
Loop

End

   Sub Leds(byval Count As Byte)
      Reset Portb.1 : Waitms 500
      For I = 1 To Count
      Set Portb.1 : Set Portd.4 : Waitms 500
      Reset Portb.1 : Reset Portd.4 : Waitms 500
      Next I
   End Sub

   Sub Left_blink
      Led_on = 0 : Led_off = 0
      For I = 1 To 10
         Config Timer0 = Timer , Prescale = 1 : Tccr0a = &B10010010       'blink LEFT irLED
         Waitus 500
         Led_on = Led_on + Pind.0
         Config Timer0 = Timer , Prescale = 1 : Tccr0a = &B10100010       'ALL TURN OFF
         Waitus 500
         Led_off = Led_off + Pind.0
      Next I

      If Led_on = 0 And Led_off = 10 Then
         Portd.4 = 1
         Object = Object + Left_object
         Else
         Portd.4 = 0
      End If
      Waitms 10                                             'THIS IS THE MINIMUM POSSIBLE VALUE
   End Sub

   Sub Right_blink
      Led_on = 0 : Led_off = 0
      For I = 1 To 10
         Config Timer0 = Timer , Prescale = 1 : Tccr0a = &B01100010       'blink RIGHT irLED
         Waitus 500
         Led_on = Led_on + Pinb.0
         Config Timer0 = Timer , Prescale = 1 : Tccr0a = &B10100010       'ALL TURN OFF
         Waitus 500
         Led_off = Led_off + Pinb.0
      Next I

      If Led_on = 0 And Led_off = 10 Then
         Portb.1 = 1
         Object = Object + Right_object
         Else
         Portb.1 = 0
      End If
      Waitms 10                                             'THIS IS THE MINIMUM POSSIBLE VALUE
   End Sub

   Sub Button
      Getrc5(address , Command)
      If Address = 0 Then
         Command = Command And &B01111111
         Waitms 200
      End If
   End Sub

   Sub Go_forward
      Pwm1a = 246                                           'Pwm1A=RIGHT SERVO, 246=forward, 214=back, 230=stop
      Pwm1b = 214                                           'Pwm1B=LEFT SERVO, 214=forward, 246=back, 230=stop
   End Sub

   Sub Go_back
      Pwm1a = 214
      Pwm1b = 246
   End Sub

   Sub Stop_it
      Pwm1a = 230
      Pwm1b = 230
   End Sub

   Sub Go_left
      Pwm1a = 246
      Pwm1b = 230
   End Sub

   Sub Turn_left
      Pwm1a = 246
      Pwm1b = 246
   End Sub

   Sub Go_right
      Pwm1a = 230
      Pwm1b = 214
   End Sub

   Sub Turn_right
      Pwm1a = 214
      Pwm1b = 214
   End Sub

   Sub Back_left
      Pwm1a = 214
      Pwm1b = 230
   End Sub

   Sub Back_right
      Pwm1a = 230
      Pwm1b = 246
   End Sub