$PROG &HFF,&HFF,&HDF,&H00' generated. Take care that the chip supports all fuse bytes.'Author: Rodman, vitalijrodnov@gmail.com
'
$regfile = "attiny2313.dat"
$crystal = 10000000
'----------------------------------------------------------------------------------
'Calculate IR LED frequency to match IR detector frequency:
'
'                      Crystal Frequency (Hz)         10000000    10000000
' Ocr0a = Ocr0b =  -------------------------------- = --------- = -------- = 131
'                   IR Receiver Frequency(Hz) * 2     38000 * 2    76000
'
'                                                  8000000
' For 8MHz crystal and 36kHz receiver it will be ---------- = 111
'                                                  36000*2
'----------------------------------------------------------------------------------
'=========================     BAILYS    ==========================================
'----------------------------------------------------------------------------------
Declare Sub Left_blink
Declare Sub Right_blink
Declare Sub Go_forward
Declare Sub Go_back
Declare Sub Go_left
Declare Sub Turn_left
Declare Sub Go_right
Declare Sub Turn_right
Declare Sub Stop_it
Declare Sub Back_left
Declare Sub Back_right

Dim Led_on As Byte , Led_off As Byte
Dim Object As Byte , I As Byte
Const No_object = 0
Const Right_object = 1
Const Left_object = 4
Const Center_object = 5

Ocr0a = 131 : Ocr0b = 131

Config Pinb.3 = Output                                      'LEFT irLED x2 driver
Config Pinb.4 = Output                                      'RIGHT irLED x2 driver
Config Pind.0 = Input                                       'LEFT RECEIVER OUTPUT
Config Pinb.0 = Input                                       'RIGHT RECEIVER OUTPUT
Config Pind.4 = Output                                      'LEFT visual DETECT
Config Pinb.1 = Output                                      'RIGHT visual DETECT
Config Portd.5 = Output                                     'LEFT SERVO CONTROL
Config Portb.2 = Output                                     'RIGHT SERVO CONTROL

For I = 1 To 5                                              'AVR start OK, flash LED 5 times
Set Portb.1 : Waitms 500
Reset Portb.1 : Waitms 500
Next I

Config Timer1 = Pwm , Pwm = 8 , Compare A Pwm = Clear Up , Compare B Pwm = Clear Up , Prescale = 256

Enable Interrupts



Do

Left_blink
Right_blink

If Object = No_object Then
   Stop_it
Elseif Object = Right_object Then
   Back_left
Elseif Object = Left_object Then
   Back_right
Elseif Object = Center_object Then
   Go_back
End If
Object = 0

Loop


End


   Sub Left_blink
      Led_on = 0 : Led_off = 0
      For I = 1 To 5
         Config Timer0 = Timer , Prescale = 1 : Tccr0a = &B10010010       'blink LEFT irLED
         Waitus 600
         Led_on = Led_on + Pind.0
         Config Timer0 = Timer , Prescale = 1 : Tccr0a = &B10100010       'ALL TURN OFF
         Waitus 600
         Led_off = Led_off + Pind.0
      Next I

      If Led_on = 0 And Led_off = 5 Then
         Portd.4 = 1
         Object = Left_object
         Else
         Portd.4 = 0
      End If
      '===============================================================================================
      Waitms 10                                             'THIS IS THE MINIMUM POSSIBLE VALUE
      '===============================================================================================
   End Sub

   Sub Right_blink
      Led_on = 0 : Led_off = 0
      For I = 1 To 5
         Config Timer0 = Timer , Prescale = 1 : Tccr0a = &B01100010       'blink RIGHT irLED
         Waitus 600
         Led_on = Led_on + Pinb.0
         Config Timer0 = Timer , Prescale = 1 : Tccr0a = &B10100010       'ALL TURN OFF
         Waitus 600
         Led_off = Led_off + Pinb.0
      Next I

      If Led_on = 0 And Led_off = 5 Then
         Portb.1 = 1
         Object = Object + Right_object
         Else
         Portb.1 = 0
      End If
      '===============================================================================================
      Waitms 10                                             'THIS IS THE MINIMUM POSSIBLE VALUE
      '===============================================================================================
   End Sub

   Sub Go_forward
      Pwm1a = 246                                           'Pwm1A=RIGHT SERVO, 246=forward, 214=back, 230=stop
      Pwm1b = 214                                           'Pwm1B=LEFT SERVO, 214=forward, 246=back, 230=stop
   End Sub

   Sub Go_back
      Pwm1a = 214
      Pwm1b = 246
   End Sub

   Sub Stop_it
      Pwm1a = 230
      Pwm1b = 230
   End Sub

   Sub Go_left
      Pwm1a = 246
      Pwm1b = 230
   End Sub

   Sub Turn_left
      Pwm1a = 246
      Pwm1b = 246
   End Sub

   Sub Go_right
      Pwm1a = 230
      Pwm1b = 214
   End Sub

   Sub Turn_right
      Pwm1a = 214
      Pwm1b = 214
   End Sub

   Sub Back_left
      Pwm1a = 214
      Pwm1b = 230
   End Sub

   Sub Back_right
      Pwm1a = 230
      Pwm1b = 246
   End Sub